Redmine - Patch #26682

URL-escape the ! character in generated markup for dropped uploads
2017-08-14 15:26 - Holger Just

Status: Closed Start date:

Priority: Normal Due date:

Assignee: Jean-Philippe Lang % Done: 0%
Category: Text formatting Estimated time: 0.00 hour
Target version: 3.4.3

Description

In #26071, we introduced the ability to just drag an image into a textbox and have Redmine generate the correct image markup for
the uploaded file for easy inclusion.

Unfortunately, the ! character in the filename is not escaped here. Thus, when using Textile as the markup language and if the
filename of the dropped file contains a | character, the resulting markup will be invalid and the image will not be correctly referenced
in the generated HTML.

The attached patch fixes this by explicitly percent-escaping the exclamation mark. While this step is not strictly required for
markdown, it doesn't hurt there since the escaped version is strictly equivalent to the unescaped one for URLs.

Related issues:
Related to Redmine - Feature #26071: Generate markup for uploaded image dropp... Closed

Associated revisions

Revision 16995 - 2017-10-15 13:36 - Jean-Philippe Lang

URL-escape additional characters with special meaning in the generated markup for dropped uploads (#26682).

Patch by Holger Just.

Revision 16996 - 2017-10-15 13:37 - Jean-Philippe Lang
Merged r16995 (#26682).

History

#1 - 2017-08-15 04:34 - Go MAEDA
- File 26682-before@2x.png added
- File 26682-after@2x.png added

- Target version set to 3.4.3

Confirmed the problem. Setting target version to 3.4.3.
Thank you for sharing the patch.
#2 - 2017-08-15 05:05 - Go MAEDA
- File parentheses@2x.png added

- Status changed from New to Needs feedback

- Assignee set to Holger Just

'("and ") have to be escaped for Markdown formatter.
Holger, would you update the patch to escape those characters?
#3 - 2017-08-15 12:11 - Holger Just

- File 0001-URL-escape-additional-characters-with-special-meanin.patch added

Thank you for the review Maeda-san. | had a look at the Markdown generation but completely missed the parenthesis. In addition to that, it turns out
that in my previous patch, only the first instance of an exclamation mark would have been escaped

The attached patch fixes both of these issues. It completely supersedes the previous patch.

#4 - 2017-08-16 04:56 - Go MAEDA
- Status changed from Needs feedback to New

- Assignee deleted (Holger Just)

| have tested the updated patch (#26682#note-3). Now it works fine in both Markdown and Textile.

Thank you for updating the patch so quickly.

#5 - 2017-08-16 04:57 - Go MAEDA

- Related to Feature #26071: Generate markup for uploaded image dropped into wiki-edit textarea added

#6 - 2017-10-15 13:37 - Jean-Philippe Lang
- Status changed from New to Closed

- Assignee set to Jean-Philippe Lang

Patch committed, thanks.
